routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/exceltopdf', 'ExcelController@index')->name('exceltopdf');
Route::get('/excel', 'ExcelController@getXlsx')->name('xlsx');

Route::get('/register', function(){return redirect('/');})->name('register');
Route::get('/register', 'Auth\RegisterController@showRegistrationForm')->name('register');

// Startpage
Route::get('/', function () { return view('welcome'); })->name('welcome');
Route::get('/impressum', function(){ return view('main.impressum'); })->name('main.impressum');
Route::get('/agb', function(){ return view('main.agb'); })->name('main.agb');
Route::get('/datenschutz', function(){ return view('main.datenschutz'); })->name('main.datenschutz');
Route::get('/faq', function(){ return view('main.faq'); })->name('main.faq');
Route::get('/versand-und-zahlungsbedingungen', function(){ return view('main.versand-und-zahlungsbedingungen'); })->name('main.versand-und-zahlungsbedingungen');
Route::get('/widerrufsrecht', function(){ return view('main.widerrufsrecht'); })->name('main.widerrufsrecht');
Route::get('/zahlungsarten', function(){ return view('main.zahlungsarten'); })->name('main.zahlungsarten');
Route::get('/newsletter-anmelden', function(){ return view('main.newsletter.anmelden'); })->name('main.newsletter.anmelden');
Route::get('/autogrammkarten', function(){ return view('main.autogrammkarten'); })->name('main.autogrammkarten');
Route::get('/ernaehrungsportal', function(){ return view('main.ernaehrungsportal'); })->name('main.ernaehrungsportal');
Route::get('/fussballtraining', function(){ return view('main.fussballtraining'); })->name('main.fussballtraining');
Route::get('/verletzungsportal', function(){ return view('main.verletzungsportal'); })->name('main.verletzungsportal');
Route::get('/preise', function(){ return view('main.preise'); })->name('main.preise');
Route::get('/telefonliste', function(){ return view('main.telefonliste'); })->name('main.telefonliste');
Route::get('/rueckennummern', function(){ return view('main.rueckennummern'); })->name('main.rueckennummern');
Route::get('/strafen-und-mannschaftskasse', function(){ return view('main.strafen-und-mannschaftskasse'); })->name('main.strafen-und-mannschaftskasse');

//Kontakt
Route::get('/kontakt', function(){ return view('main.kontakt.index'); })->name('main.kontakt.index');
Route::post('/kontakt', 'ContactController@send' )->name('main.kontakt.send');

// BLOG
Route::post('/fussball-news/suchen', 'BlogController@searchRedirect')->name('blog.search.redirect');
Route::get('/fussball-news/suchen/{search?}', 'BlogController@search')->name('blog.search');
Route::get('/fussball-news/{category?}/{subcategory?}', 'BlogController@index')->name('blog.index');
Route::get('/fussball-news/{category}/{subcategory}/{slug}-{id}', 'BlogController@show')->name('blog.show')->where('slug', '.*(?=-)');

// TRAININGSÜBUNGEN
Route::post('/trainingsuebungen/suchen', 'WorkoutController@searchRedirect')->name('workout.search.redirect');
Route::get('/trainingsuebungen/suchen/{search?}', 'WorkoutController@search')->name('workout.search');
Route::get('/trainingsuebungen/{category?}/{subcategory?}', 'WorkoutController@index')->name('workout.index');
Route::get('/trainingsuebungen/{category}/{subcategory}/{slug}-{id}', 'WorkoutController@show')->name('workout.show')->where('slug', '.*(?=-)');

// GAMEFIELD-PLANER
Route::get('/spielfeldplaner', 'GamefieldController@index')->name('gamefield');


//Search Engine
Route::get('/vereinsverzeichnis/', 'SearchController@index')->name('search.index');
Route::get('/vereinsverzeichnis/search/{text?}', 'SearchController@search')->name('search.search');
Route::get('/vereinsverzeichnis/verein/{club}', 'ClubController@index')->name('club.show');
Route::get('/vereinsverzeichnis/verband/{association}', 'AssociationController@index')->name('association.show');

//Submissions
Route::get('/vereinsverzeichnis/submissions/create', 'SubmissionController@create')->name('submissions.create');
Route::get('/vereinsverzeichnis/submissions/{club}/edit', 'SubmissionController@edit')->name('submissions.edit');
Route::post('/vereinsverzeichnis/submissions/{club}', 'SubmissionController@update')->name('submissions.update');
Route::post('/vereinsverzeichnis/submissions', 'SubmissionController@store')->name('submissions.store');


// AUTH
Route::group(['middleware' => 'auth'],function() {

    // BACKEND
    Route::group(['middleware' => 'isAdmin', 'namespace' => 'Backend', 'prefix' => 'backend', 'as' => 'backend.'], function () {

        // DASHBOARD
        Route::get('/', function () {
            return redirect()->route('backend.dashboard.index');
        })->name('home');

        Route::resource('/dashboard', 'DashboardController');

        // ADMINISTRATION
        Route::group(['namespace' => 'Admin', 'as' => 'admin.', 'prefix' => 'admin'], function () {
            Route::group(['namespace' => 'Settings', 'as' => 'settings.', 'prefix' => 'einstellungen'], function () {
                Route::group(['namespace' => 'System', 'as' => 'system.', 'prefix' => 'system'], function () {
                    Route::get('/newsticker', 'NewsTickerController@edit')->name('newsticker.edit');
                    Route::post('/newsticker', 'NewsTickerController@update')->name('newsticker.update');
                    Route::get('blog-hintergrund/{setting}', 'SettingController@edit')->name('blog-background.edit');
                    Route::put('blog-hintergrund/{setting}', 'SettingController@update')->name('blog-background.update');
                });

                Route::group(['namespace' => 'Functions', 'as' => 'functions.', 'prefix' => 'funktionen'], function () {
                    Route::group(['namespace' => 'Blog', 'as' => 'blog.', 'prefix' => 'blog'], function () {
                        Route::resource('/categories', 'CategoryController');
                        Route::resource('/subcategories', 'SubCategoryController');
                    });
                    Route::group(['namespace' => 'Workout', 'as' => 'workout.', 'prefix' => 'trainingsuebungen'], function () {
                        Route::resource('/categories', 'CategoryController');
                        Route::resource('/subcategories', 'SubCategoryController');
                    });
                });
            });


            Route::resource('/submissions', 'SubmissionController');
            Route::resource('/clubs', 'ClubController');
            Route::resource('/associations', 'AssociationController');


            Route::resource('/benutzer', 'UserController',['parameters' => ['benutzer' => 'user'], 'names' => 'users']);
        });

        // BLOG
        Route::group(['as' => 'blog.', 'prefix' => 'blog'], function () {
            Route::resource('/posts', 'BlogController',['except' => ['show','index','create']]);
            Route::get('/posts/{cat?}', 'BlogController@index')->name('posts.index');
            Route::get('/posts/create/{cat?}', 'BlogController@create')->name('posts.create');
        });

        // TRAININGSÜBUNGEN
        Route::group(['as' => 'workout.', 'prefix' => 'trainingsuebungen'], function () {
            Route::resource('/posts', 'WorkoutController',['except' => ['show','index','create']]);
            Route::get('/posts/{cat?}', 'WorkoutController@index')->name('posts.index');
            Route::get('/posts/create/{cat?}', 'WorkoutController@create')->name('posts.create');
        });




    });

});

app/Models/Blog/Category.php
<?php

namespace App\Models\Blog;

use Cviebrock\EloquentSluggable\Sluggable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Cache;

class Category extends Model
{
    use Sluggable;

    protected $table = "blog__categories";

    public function sluggable()
    {
        return [
            'slug' => [
                'source' => 'name'
            ]
        ];
    }

    public function childs(){
        return $this->hasMany('App\Models\Blog\SubCategory','category_id','id');
    }

    public function link(){
        return route('blog.index',[$this->slug]);
    }

    public function posts(){
        return $this->hasManyThrough('App\Models\Blog\Post','App\Models\Blog\SubCategory','category_id','subcategory_id');
    }

    public function activePosts(){
        return $this->posts()->where('active',1);
    }

    public function unactivePosts(){
        return $this->posts()->where('active',0);
    }

    public function updateCache(){
        Cache::forget('blog.categories');
    }

}

app/Http/Controllers/Backend/Admin/Settings/Functions/Blog/CategoryController.php
<?php

namespace App\Http\Controllers\Backend\Admin\Settings\Functions\Blog;

use App\Models\Blog\Category;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('backend.admin.settings.functions.blog.categories.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $headerimages = scandir('vendor/blog/img');
        return view('backend.admin.settings.functions.blog.categories.create',['headerimages' => $headerimages]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //VALIDATE
        $request->validate([
            'name' => 'required|string',
            'ordering' => 'nullable|integer',
            'seotitle' => 'nullable|string',
            'seodescription' => 'nullable|string',
            'color' => 'required|integer|min:1|max:5',
            'headerimage' => 'nullable|string'
        ]);

        //SAVE
        $cat = new Category();

        $cat->name = $request->input('name');
        $cat->ordering = $request->input('ordering');
        $cat->seotitle = $request->input('seotitle');
        $cat->seodescription = $request->input('seodescription');
        $cat->color = $request->input('color');
        $cat->headerimage = $request->input('headerimage');
        $cat->save();
        $cat->updateCache();

        return redirect()->route('backend.admin.settings.functions.blog.categories.index');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Blog\Category  $blogCategory
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        $headerimages = scandir('vendor/blog/img');
        return view('backend.admin.settings.functions.blog.categories.edit',['cat' => $category, 'headerimages' => $headerimages]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Blog\Category  $blogCategory
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Category $category)
    {
        //VALIDATE
        $request->validate([
            'name' => 'required|string',
            'ordering' => 'nullable|integer',
            'seotitle' => 'nullable|string',
            'seodescription' => 'nullable|string',
            'color' => 'required|integer|min:1|max:5',
            'headerimage' => 'nullable|string'
        ]);

        //SAVE
        $category->name = $request->input('name');
        $category->ordering = $request->input('ordering');
        $category->seotitle = $request->input('seotitle');
        $category->seodescription = $request->input('seodescription');
        $category->color = $request->input('color');
        $category->headerimage = $request->input('headerimage');
        $category->save();
        $category->updateCache();

        return redirect()->route('backend.admin.settings.functions.blog.categories.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Blog\Category  $blogCategory
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {
        $category->delete();
        $category->updateCache();

        return redirect()->route('backend.admin.settings.functions.blog.categories.index');
    }
}

app/Http/Controllers/Backend/Admin/Settings/Functions/Blog/SubCategoryController.php
<?php

namespace App\Http\Controllers\Backend\Admin\Settings\Functions\Blog;

use App\Models\Blog\SubCategory;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SubCategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('backend.admin.settings.functions.blog.subcategories.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $headerimages = scandir('vendor/blog/img');
        return view('backend.admin.settings.functions.blog.subcategories.create',['headerimages' => $headerimages]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //VALIDATE
        $request->validate([
            'name' => 'required|string',
            'ordering' => 'nullable|integer',
            'seotitle' => 'nullable|string',
            'seodescription' => 'nullable|string',
            'color' => 'required|integer|min:1|max:5',
            'parent' => 'nullable|exists:blog__categories,id',
            'headerimage' => 'nullable|string'
        ]);

        //SAVE
        $cat = new SubCategory();

        $cat->name = $request->input('name');
        $cat->ordering = $request->input('ordering');
        $cat->seotitle = $request->input('seotitle');
        $cat->seodescription = $request->input('seodescription');
        $cat->color = $request->input('color');
        $cat->category_id = $request->input('parent');
        $cat->headerimage = $request->input('headerimage');
        $cat->save();
        $cat->updateCache();

        return redirect()->route('backend.admin.settings.functions.blog.subcategories.index');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Blog\SubCategory  $blogSubCategory
     * @return \Illuminate\Http\Response
     */
    public function edit(SubCategory $subcategory)
    {
        $headerimages = scandir('vendor/blog/img');
        return view('backend.admin.settings.functions.blog.subcategories.edit',['cat' => $subcategory, 'headerimages' => $headerimages]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Blog\SubCategory  $blogSubCategory
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, SubCategory $subcategory)
    {
        //VALIDATE
        $request->validate([
            'name' => 'required|string',
            'ordering' => 'nullable|integer',
            'seotitle' => 'nullable|string',
            'seodescription' => 'nullable|string',
            'color' => 'required|integer|min:1|max:5',
            'parent' => 'nullable|exists:blog__categories,id',
            'headerimage' => 'nullable|string'
        ]);

        //SAVE
        $subcategory->name = $request->input('name');
        $subcategory->ordering = $request->input('ordering');
        $subcategory->seotitle = $request->input('seotitle');
        $subcategory->seodescription = $request->input('seodescription');
        $subcategory->color = $request->input('color');
        $subcategory->category_id = $request->input('parent');
        $subcategory->headerimage = $request->input('headerimage');
        $subcategory->save();
        $subcategory->updateCache();

        return redirect()->route('backend.admin.settings.functions.blog.subcategories.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Blog\SubCategory  $blogSubCategory
     * @return \Illuminate\Http\Response
     */
    public function destroy(SubCategory $subcategory)
    {
        $subcategory->delete();
        $subcategory->updateCache();

        return redirect()->route('backend.admin.settings.functions.blog.subcategories.index');
    }
}

resources/views/backend/admin/settings/functions/blog/categories/create.blade.php
@extends('layouts.backend.app')

@section('page-title', 'Blog - Kategorie Erstellen')

@section('content')

    <!-- widget grid -->
    <section id="widget-grid" class="">

        <!-- row -->
        <div class="row">

            <!-- NEW WIDGET START -->
            <article class="col-xs-12 col-sm-12 col-md-12 col-lg-12">

                <!-- Widget ID (each widget will need unique ID)-->
                <div class="jarviswidget" id="wid-id-0" data-widget-togglebutton="false" data-widget-editbutton="false" data-widget-colorbutton="false" data-widget-deletebutton="false" data-widget-fullscreenbutton="false">

                    <header>
                        <span class="widget-icon"> <i class="fa fa-comments"></i> </span>
                        <h2>Blog - Kategorie Erstellen </h2>

                    </header>

                    <!-- widget div-->
                    <div>

                        <!-- widget edit box -->
                        <div class="jarviswidget-editbox">
                            <!-- This area used as dropdown edit box -->
                            <input class="form-control" type="text">
                        </div>
                        <!-- end widget edit box -->

                        <!-- widget content -->
                        <div class="widget-body">

                            <!-- this is what the user will see -->

                            <form class="form-horizontal" method="POST" action="{{route('backend.admin.settings.functions.blog.categories.store')}}">

                                {{csrf_field()}}

                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="name">Name:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="name" class="form-control" name="name" type="text" value="{{old('name')}}" required />
                                    </div>

                                    <label class="col-md-2 col-sm-4 control-label" for="ordering">Reihenfolge:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="ordering" class="form-control" name="ordering" type="text" value="{{old('ordering')}}" />
                                    </div>

                                </div>

                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="seotitle">SEO-Title:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="seotitle" class="form-control" name="seotitle" type="text" value="{{old('seotitle')}}" />
                                    </div>

                                    <label class="col-md-2 col-sm-4 control-label" for="seodescription">SEO-Description:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="seodescription" class="form-control" name="seodescription" type="text" value="{{old('seodescription')}}" />
                                    </div>

                                </div>

                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="color">Farbe:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <select id="color" name="color" class="form-control" required>
                                            @foreach([1 => 'Rot', 2 => 'Blau', 3 => 'Gelb', 4 => 'Schwarz', 5 => 'Grau'] as $id => $color)
                                                <option value="{{$id}}" @if(old('color') == $id) selected @endif>{{$color}}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                </div>


                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="headerimage">Header-Bild:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <select id="headerimage" name="headerimage" class="form-control">
                                            <option></option>
                                            @foreach($headerimages as $image)
                                                <option value="{{$image}}" @if(old('headerimage') == $image) selected @endif>{{$image}}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                </div>

                                    <div class="form-group">
                                    <div class="col-md-4 col-sm-8 col-md-offset-2 col-sm-offset-4">
                                        <button type="submit" class="btn btn-default">Speichern</button>
                                    </div>
                                </div>



                            </form>


                        </div>
                        <!-- end widget content -->

                    </div>
                    <!-- end widget div -->

                </div>
                <!-- end widget -->

            </article>
            <!-- WIDGET END -->

        </div>

        <!-- end row -->



    </section>
    <!-- end widget grid -->
@endsection

resources/views/backend/admin/settings/functions/blog/categories/edit.blade.php
@extends('layouts.backend.app')

@section('page-title', 'Blog - Kategorie Bearbeiten')

@section('content')

    <!-- widget grid -->
    <section id="widget-grid" class="">

        <!-- row -->
        <div class="row">

            <!-- NEW WIDGET START -->
            <article class="col-xs-12 col-sm-12 col-md-12 col-lg-12">

                <!-- Widget ID (each widget will need unique ID)-->
                <div class="jarviswidget" id="wid-id-0" data-widget-togglebutton="false" data-widget-editbutton="false" data-widget-colorbutton="false" data-widget-deletebutton="false" data-widget-fullscreenbutton="false">

                    <header>
                        <span class="widget-icon"> <i class="fa fa-comments"></i> </span>
                        <h2>Blog - Kategorie Bearbeiten </h2>

                    </header>

                    <!-- widget div-->
                    <div>

                        <!-- widget edit box -->
                        <div class="jarviswidget-editbox">
                            <!-- This area used as dropdown edit box -->
                            <input class="form-control" type="text">
                        </div>
                        <!-- end widget edit box -->

                        <!-- widget content -->
                        <div class="widget-body">

                            <!-- this is what the user will see -->

                            <form class="form-horizontal" method="POST" action="{{route('backend.admin.settings.functions.blog.categories.update',$cat->id)}}">

                                {{csrf_field()}}
                                {{method_field('PUT')}}

                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="name">Name:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="name" class="form-control" name="name" type="text" value="{{old('name',$cat->name)}}" required />
                                    </div>

                                    <label class="col-md-2 col-sm-4 control-label" for="ordering">Reihenfolge:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="ordering" class="form-control" name="ordering" type="text" value="{{old('ordering',$cat->ordering)}}" />
                                    </div>

                                </div>

                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="seotitle">SEO-Title:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="seotitle" class="form-control" name="seotitle" type="text" value="{{old('seotitle', $cat->seotitle)}}" />
                                    </div>

                                    <label class="col-md-2 col-sm-4 control-label" for="seodescription">SEO-Description:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <input id="seodescription" class="form-control" name="seodescription" type="text" value="{{old('seodescription', $cat->seodescription)}}" />
                                    </div>

                                </div>

                                <div class="form-group">

                                    <label class="col-md-2 col-sm-4 control-label" for="color">Farbe:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <select id="color" name="color" class="form-control" required>
                                            @foreach([1 => 'Rot', 2 => 'Blau', 3 => 'Gelb', 4 => 'Schwarz', 5 => 'Grau'] as $id => $color)
                                                <option value="{{$id}}" @if(old('color',$cat->color) == $id) selected @endif>{{$color}}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                    <label class="col-md-2 col-sm-4 control-label" for="headerimage">Header-Bild:</label>
                                    <div class="col-md-4 col-sm-8">
                                        <select id="headerimage" name="headerimage" class="form-control">
                                            <option></option>
                                            @foreach($headerimages as $image)
                                                <option value="{{$image}}" @if(old('headerimage',($cat->headerimage ?? 'fussball_blog.png')) == $image) selected @endif>{{$image}}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                </div>

                                <div class="form-group">
                                    <div class="col-md-4 col-sm-8 col-md-offset-2 col-sm-offset-4">
                                        <button type="submit" class="btn btn-default">Ändern</button>
                                        <button form="form_delete" type="submit" class="btn btn-danger">Löschen</button>
                                    </div>
                                </div>



                            </form>

                            <form id="form_delete" method="POST" action="{{route('backend.admin.settings.functions.blog.categories.destroy',$cat->id)}}">
                                {{csrf_field()}}
                                {{method_field('DELETE')}}
                            </form>


                        </div>
                        <!-- end widget content -->

                    </div>
                    <!-- end widget div -->

                </div>
                <!-- end widget -->

            </article>
            <!-- WIDGET END -->

        </div>

        <!-- end row -->



    </section>
    <!-- end widget grid -->
@endsection